#!/bin/bash
#
# Compile JUnit Java classes using GCJ
#
# Created:  2004-10-19
# Issued:   2004-10-19
# Modified: 2005-10-13
#
# Only compiles core classes and text user interface, not
# AWT or Swing graphical user interfaces.
#
# Where dependencies exist amongst the packages, GCJ
# seems to require primary dependencies to be compiled
# first, hence the compile sequence.
#
###########################################################

mk_bin=`dirname $0`

# echo ""
# echo "Script directory = $mk_bin"

$mk_bin/test-environment.sh

echo ""
echo "Cleaning build directory..."

rm -rf $mk_build/junit

echo ""
echo "Preparing build directory..."

mkdir -p $mk_build/junit

echo ""
echo "Compiling JUnit..."

gcj --encoding=ISO-8859-1 -classpath .:$mk_build/junit -C -d $mk_build/junit $mk_home/lib-src/junit/junit/framework/*.java
gcj --encoding=ISO-8859-1 -classpath .:$mk_build/junit -C -d $mk_build/junit $mk_home/lib-src/junit/junit/runner/*.java
gcj --encoding=ISO-8859-1 -classpath .:$mk_build/junit -C -d $mk_build/junit $mk_home/lib-src/junit/junit/extensions/*.java
gcj --encoding=ISO-8859-1 -classpath .:$mk_build/junit -C -d $mk_build/junit $mk_home/lib-src/junit/junit/textui/*.java

echo ""
echo "JUnit compiled to $mk_build/junit"
