#!/bin/bash
#
# Generate a WAR deployment for MKSearch
#
# Created:  2005-10-13
# Issued:   2005-10-13
# Modified: 2005-10-14
#
###########################################################

mk_bin=`dirname $0`

# echo ""
# echo "Script directory = $mk_bin"

$mk_bin/test-environment.sh

# Compile and JAR the source
$mk_home/bin/jar-sesame.sh
$mk_home/bin/jar-mksearch.sh

echo ""
echo "Cleaning build directory..."

rm -rf $mk_build/war

echo ""
echo "Preparing build directory..."

mkdir -p $mk_build/war
mkdir -p $mk_build/war/styles
mkdir -p $mk_build/war/META-INF
mkdir -p $mk_build/war/WEB-INF
mkdir -p $mk_build/war/WEB-INF/lib
mkdir -p $mk_build/war/WEB-INF/rdf

echo ""
echo "Copying application source..."
# 'Clean' copy avoids Subversion repository artefacts

cp -p -r $mk_home/src/app/*.jsp $mk_build/war
cp -p -r $mk_home/src/app/styles/*.css $mk_build/war/styles
cp -p -r $mk_home/src/app/WEB-INF/*.tld $mk_build/war/WEB-INF
cp -p -r $mk_home/src/app/WEB-INF/*.xml $mk_build/war/WEB-INF
cp -p -r $mk_home/src/app/WEB-INF/rdf/*.rdf $mk_build/war/WEB-INF/rdf

cp -p -r $mk_home/dist/mksearch.jar $mk_build/war/WEB-INF/lib/mksearch.jar
cp -p -r $mk_home/lib/sesame.jar $mk_build/war/WEB-INF/lib/sesame.jar

cp -p -r $mk_home/src/app/META-INF/MANIFEST.MF $mk_build/war/META-INF/MANIFEST.MF

# Change to base directory to root the archive correctly
cd $mk_build/war

# Call GCJ fastjar on the current directory
jar cvf $mk_home/dist/mksearch.war .

echo ""
echo "MKSearch WAR output to $mk_home/dist/mksearch.war"
