package com.mkdoc.query;

/*
    Created:    2005-07-06
    Issued:     2005-07-06
    Modified:   2005-07-06

    Author:     Philip Shaw <phil@mkdoc.com>
    Copyright:  (c) 2005 MKDoc Ltd.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or (at
    your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    USA
*/

import org.hansel.CoverageDecorator;

import junit.framework.Test;

/**
 *  Code coverage test suite for <code>ServletQueryBuilder</code>.
 *  @version    0.1 2005-07-06
 *  @author     Philip Shaw <phil@mkdoc.com>
 */
public class ServletQueryBuilderCoverageTest extends ServletQueryBuilderTest {

    /**
     *  Named test instance.
     *  @param  name    The name of the test case.
     *  @since  Version 0.1 2005-07-06
     */
    public ServletQueryBuilderCoverageTest(final String name) {

        super(name);
    }

    /**
     *  Override the primary test class with a coverage decorator.
     *  @return A test coverage decorator.
     *  @since  Version 0.1 2005-07-06
     */
    public static Test suite() {

        return new CoverageDecorator(ServletQueryBuilderTest.class,
                                     new Class[] {ServletQueryBuilder.class,
                                                  AbstractQueryBuilder.class});
    }

}
