/* Generated By:JavaCC: Do not edit this line. RdqlParser.java */
package org.openrdf.sesame.query.rdql.parser;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.openrdf.sesame.query.QueryEvaluationException;
import org.openrdf.sesame.query.rdql.model.And;
import org.openrdf.sesame.query.rdql.model.BooleanConstant;
import org.openrdf.sesame.query.rdql.model.BooleanExpr;
import org.openrdf.sesame.query.rdql.model.ConstantExpr;
import org.openrdf.sesame.query.rdql.model.Expression;
import org.openrdf.sesame.query.rdql.model.IntegerConstant;
import org.openrdf.sesame.query.rdql.model.MathExpr;
import org.openrdf.sesame.query.rdql.model.Not;
import org.openrdf.sesame.query.rdql.model.NullConstant;
import org.openrdf.sesame.query.rdql.model.NumberCompare;
import org.openrdf.sesame.query.rdql.model.Or;
import org.openrdf.sesame.query.rdql.model.RealConstant;
import org.openrdf.sesame.query.rdql.model.SfwQuery;
import org.openrdf.sesame.query.rdql.model.StringConstant;
import org.openrdf.sesame.query.rdql.model.TripleSelector;
import org.openrdf.sesame.query.rdql.model.URI;
import org.openrdf.sesame.query.rdql.model.ValueCompare;
import org.openrdf.sesame.query.rdql.model.Var;
import org.openrdf.sesame.query.rdql.model.Xor;

public class RdqlParser implements RdqlParserConstants {

        /** Variable **/
        protected Map _varMap = new HashMap();
        protected List _varList = new ArrayList();

        public Var getSharedVar(String name) {
                Var result = (Var)_varMap.get(name);

                if (result == null) {
                        // Create a new Var
                        //System.out.println("Creating new Var: " + name);
                        result = new Var(name);
                        _varMap.put(name, result);
                        _varList.add(result);
                }

                return result;
        }

        public List getVarList() {
                return _varList;
        }

        private int _varNo = 1;
        public String getAnonymousVarName() {
                return "_" + _varNo++;
        }

        /** namespaces **/
        protected Map _nsMap = new HashMap();

        public void addNamespace(String prefix, String namespace) {
                _nsMap.put(prefix, namespace);
        }

        public String getNamespace(String prefix) {
                return (String)_nsMap.get(prefix);
        }

  final public SfwQuery parse() throws ParseException {
        SfwQuery q;

        // (re)set _varNo to '1'
        _varNo = 1;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case USING:
      jj_consume_token(USING);
      namespace();
      label_1:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[0] = jj_gen;
          break label_1;
        }
        jj_consume_token(COMMA);
        namespace();
      }
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
    q = sfw_query();
    jj_consume_token(0);
                                {if (true) return q;}
    throw new Error("Missing return statement in function");
  }

/*-------------------------------------------------+
| NAMESPACE DECLARATIONS                           |
+-------------------------------------------------*/
  final public void namespace() throws ParseException {
        Token prefixToken, nsToken;
    prefixToken = jj_consume_token(NSPREFIX);
    jj_consume_token(FOR);
    nsToken = jj_consume_token(QUOTED_URI);
                String prefix = prefixToken.image;
                String ns = nsToken.image;

                // remove first char ('<') and last char ('>') from ns:
                ns = ns.substring(1, ns.length() - 1);

                //FIXME: check if prefix isn't used twice?
                addNamespace(prefix, ns);
  }

/*-------------------------------------------------+
| SFW QUERY                                        |
+-------------------------------------------------*/
  final public SfwQuery sfw_query() throws ParseException {
        List varList = new ArrayList();
        List triplePatternList = new ArrayList();
        BooleanExpr suchthat = null;
    jj_consume_token(SELECT);
    vars_list(varList);
    jj_consume_token(WHERE);
    triple_patterns(triplePatternList);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case SUCHTHAT:
      jj_consume_token(SUCHTHAT);
      suchthat = boolean_query();
      break;
    default:
      jj_la1[2] = jj_gen;
      ;
    }
                if (varList.isEmpty()) {
                        // select *
                        varList = getVarList();
                }
                {if (true) return new SfwQuery(varList, triplePatternList, suchthat);}
    throw new Error("Missing return statement in function");
  }

  final public void vars_list(List varList) throws ParseException {
        Var v;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR:
      v = var();
                      varList.add(v);
      label_2:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[3] = jj_gen;
          break label_2;
        }
        jj_consume_token(COMMA);
        v = var();
                                      varList.add(v);
      }
      break;
    case STAR:
      jj_consume_token(STAR);
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void triple_patterns(List selectors) throws ParseException {
    triple_pattern(selectors);
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
      case COMMA:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_3;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        jj_consume_token(COMMA);
        break;
      default:
        jj_la1[6] = jj_gen;
        ;
      }
      triple_pattern(selectors);
    }
  }

  final public void triple_pattern(List selectors) throws ParseException {
        Var subj, pred, obj;
    jj_consume_token(LPAREN);
    subj = var_or_uri();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      break;
    default:
      jj_la1[7] = jj_gen;
      ;
    }
    pred = var_or_uri();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
    obj = var_or_literal();
    jj_consume_token(RPAREN);
                TripleSelector ts = new TripleSelector(subj, pred, obj);
                selectors.add(ts);
  }

  final public Var var_or_uri() throws ParseException {
        URI uri;
        Var var;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR:
      var = var();
                      {if (true) return var;}
      break;
    case QUOTED_URI:
    case QNAME:
      uri = uri();
                var = new Var(getAnonymousVarName());
                var.setValue( uri.getValue() );
                {if (true) return var;}
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public Var var_or_literal() throws ParseException {
        Var var;
        ConstantExpr c;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR:
      var = var();
                      {if (true) return var;}
      break;
    case TRUE:
    case FALSE:
    case NULL:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case QUOTED_URI:
    case QNAME:
      c = literal();
                var = new Var(getAnonymousVarName());
                try {
                        var.setValue( c.getValue() );
                }
                catch (QueryEvaluationException e) {
                 // do nothing, can't happen on a constant.
                }

                {if (true) return var;}
      break;
    default:
      jj_la1[10] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

/*-------------------------------------------------+
| VARIABLE, URI, LITERAL                           |
+-------------------------------------------------*/
  final public Var var() throws ParseException {
        Token t;
    t = jj_consume_token(VAR);
                String varName = t.image;
                // Remove starting question mark
                varName = varName.substring(1);
                {if (true) return (Var)getSharedVar(varName);}
    throw new Error("Missing return statement in function");
  }

  final public ConstantExpr literal() throws ParseException {
        ConstantExpr c;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case QUOTED_URI:
    case QNAME:
      c = uri();
                                {if (true) return c;}
      break;
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
      c = numeric_literal();
                                {if (true) return c;}
      break;
    case STRING_LITERAL:
      c = text_literal();
                                {if (true) return c;}
      break;
    case TRUE:
    case FALSE:
      c = boolean_literal();
                                {if (true) return c;}
      break;
    case NULL:
      c = null_literal();
                                {if (true) return c;}
      break;
    default:
      jj_la1[11] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public URI uri() throws ParseException {
        Token t;
        String uriString;
        int colonIdx;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case QUOTED_URI:
      t = jj_consume_token(QUOTED_URI);
                uriString = t.image;
                // remove first char ('<') and last char ('>'):
                uriString = uriString.substring(1, uriString.length() - 1);
                colonIdx = uriString.indexOf(':');
                if (colonIdx != -1) {
                        String prefix = uriString.substring(0, colonIdx);
                        String namespace = getNamespace(prefix);
                        if (namespace != null) {
                                uriString = namespace + uriString.substring(colonIdx + 1);
                        }
                }
                {if (true) return new URI(uriString);}
      break;
    case QNAME:
      t = jj_consume_token(QNAME);
                uriString = t.image;

                colonIdx = uriString.indexOf(':');
                if (colonIdx != -1) {
                        String prefix = uriString.substring(0, colonIdx);
                        String namespace = getNamespace(prefix);
                        if (namespace != null) {
                                uriString = namespace + uriString.substring(colonIdx + 1);
                        }
                        else {
                            {if (true) throw new ParseException("namespace prefix " + prefix + " used but not declared");}
                        }
                }
                {if (true) return new URI(uriString);}
      break;
    default:
      jj_la1[12] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public ConstantExpr numeric_literal() throws ParseException {
        Token t;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case INTEGER_LITERAL:
      t = jj_consume_token(INTEGER_LITERAL);
                int i = Integer.parseInt(t.image);
                {if (true) return new IntegerConstant(i);}
      break;
    case FLOATING_POINT_LITERAL:
      t = jj_consume_token(FLOATING_POINT_LITERAL);
                float f = Float.parseFloat(t.image);
                {if (true) return new RealConstant(f);}
      break;
    default:
      jj_la1[13] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public ConstantExpr text_literal() throws ParseException {
        Token t;
    t = jj_consume_token(STRING_LITERAL);
                String st = t.image;
                st = st.substring(1, st.length() - 1);
                {if (true) return new StringConstant(st);}
    throw new Error("Missing return statement in function");
  }

  final public ConstantExpr boolean_literal() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      jj_consume_token(TRUE);
                 {if (true) return new BooleanConstant(true);}
      break;
    case FALSE:
      jj_consume_token(FALSE);
                  {if (true) return new BooleanConstant(false);}
      break;
    default:
      jj_la1[14] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public ConstantExpr null_literal() throws ParseException {
        Token t;
    t = jj_consume_token(NULL);
                {if (true) return new NullConstant();}
    throw new Error("Missing return statement in function");
  }

/*-------------------------------------------------+
| BOOLEAN QUERIES                                  |
+-------------------------------------------------*/
  final public BooleanExpr boolean_query() throws ParseException {
        Expression arg1;
        BooleanExpr arg2 = null;
    arg1 = expression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
    case SUCHTHAT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SUCHTHAT:
        jj_consume_token(SUCHTHAT);
        break;
      case COMMA:
        jj_consume_token(COMMA);
        break;
      default:
        jj_la1[15] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      arg2 = boolean_query();
                        arg1 = new And( (BooleanExpr)arg1, arg2 );
      break;
    default:
      jj_la1[16] = jj_gen;
      ;
    }
          {if (true) return (BooleanExpr)arg1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression expression() throws ParseException {
        Expression result;
    result = or_expression();
                                   {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public Expression or_expression() throws ParseException {
        Expression arg1, arg2;
    arg1 = and_expression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OR:
      jj_consume_token(OR);
      arg2 = or_expression();
                        arg1 = new Or( (BooleanExpr)arg1, (BooleanExpr)arg2 );
      break;
    default:
      jj_la1[17] = jj_gen;
      ;
    }
          {if (true) return arg1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression xor_expression() throws ParseException {
        Expression arg1, arg2;
    arg1 = and_expression();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case XOR:
      jj_consume_token(XOR);
      arg2 = xor_expression();
                        arg1 = new Xor( (BooleanExpr)arg1, (BooleanExpr)arg2 );
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
          {if (true) return arg1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression and_expression() throws ParseException {
        Expression arg1, arg2;
    arg1 = value_logical();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AND:
      jj_consume_token(AND);
      arg2 = and_expression();
                        arg1 = new And( (BooleanExpr)arg1, (BooleanExpr)arg2 );
      break;
    default:
      jj_la1[19] = jj_gen;
      ;
    }
          {if (true) return arg1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression value_logical() throws ParseException {
        Expression result;
    result = string_eq_expr();
                                    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public Expression string_eq_expr() throws ParseException {
        boolean NEQ;
        Expression arg1, arg2;
    arg1 = eq_expr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STR_EQ:
    case STR_NE:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STR_EQ:
        jj_consume_token(STR_EQ);
                                   NEQ = false;
        break;
      case STR_NE:
        jj_consume_token(STR_NE);
                                   NEQ = true;
        break;
      default:
        jj_la1[20] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      arg2 = eq_expr();
                        arg1 = new ValueCompare(arg1, arg2);
                        if (NEQ) {
                                arg1 = new Not( (BooleanExpr)arg1 );
                        }
      break;
    default:
      jj_la1[21] = jj_gen;
      ;
    }
          {if (true) return arg1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression eq_expr() throws ParseException {
        int op = -1;
        Expression arg1, arg2;
    arg1 = relational_expr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case EQ:
    case NEQ:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EQ:
        jj_consume_token(EQ);
                        op = NumberCompare.EQ;
        break;
      case NEQ:
        jj_consume_token(NEQ);
                         op = NumberCompare.NE;
        break;
      default:
        jj_la1[22] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      arg2 = relational_expr();
                  arg1 = new NumberCompare(arg1, op, arg2);
      break;
    default:
      jj_la1[23] = jj_gen;
      ;
    }
          {if (true) return arg1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression relational_expr() throws ParseException {
        int op = -1;
        Expression arg1, arg2;
    arg1 = numeric_expr();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LT:
    case LE:
    case GE:
    case GT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LT:
        jj_consume_token(LT);
                               op = NumberCompare.LT;
        break;
      case GT:
        jj_consume_token(GT);
                               op = NumberCompare.GT;
        break;
      case LE:
        jj_consume_token(LE);
                               op = NumberCompare.LE;
        break;
      case GE:
        jj_consume_token(GE);
                               op = NumberCompare.GE;
        break;
      default:
        jj_la1[24] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      arg2 = numeric_expr();
                  arg1 = new NumberCompare(arg1, op, arg2);
      break;
    default:
      jj_la1[25] = jj_gen;
      ;
    }
          {if (true) return arg1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression numeric_expr() throws ParseException {
        Expression result;
    result = shift_expr();
                                {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public Expression shift_expr() throws ParseException {
        Expression result;
    result = additive_expr();
                                   {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public Expression additive_expr() throws ParseException {
        int op = -1;
        Expression arg1, arg2;
    arg1 = multiplicative_expr();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
      case MINUS:
        ;
        break;
      default:
        jj_la1[26] = jj_gen;
        break label_4;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PLUS:
        jj_consume_token(PLUS);
                                  op = MathExpr.PLUS;
        break;
      case MINUS:
        jj_consume_token(MINUS);
                                  op = MathExpr.MINUS;
        break;
      default:
        jj_la1[27] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      arg2 = multiplicative_expr();
                  arg1 = new MathExpr(arg1, op, arg2);
    }
          {if (true) return arg1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression multiplicative_expr() throws ParseException {
        int op = -1;
        Expression arg1, arg2;
    arg1 = unary_expression();
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
      case SLASH:
      case REM:
        ;
        break;
      default:
        jj_la1[28] = jj_gen;
        break label_5;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STAR:
        jj_consume_token(STAR);
                                  op = MathExpr.MULTIPLY;
        break;
      case SLASH:
        jj_consume_token(SLASH);
                                  op = MathExpr.DIVIDE;
        break;
      case REM:
        jj_consume_token(REM);
                                  op = MathExpr.REMAINDER;
        break;
      default:
        jj_la1[29] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      arg2 = unary_expression();
                  arg1 = new MathExpr(arg1, op, arg2);
    }
          {if (true) return arg1;}
    throw new Error("Missing return statement in function");
  }

  final public Expression unary_expression() throws ParseException {
        Expression result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
    case TRUE:
    case FALSE:
    case NULL:
    case VAR:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case QUOTED_URI:
    case QNAME:
      result = primary_expr();
                                  {if (true) return result;}
      break;
    case TILDE:
    case BANG:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TILDE:
        jj_consume_token(TILDE);
        break;
      case BANG:
        jj_consume_token(BANG);
        break;
      default:
        jj_la1[30] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      result = unary_expression();
                {if (true) return new Not( (BooleanExpr)result );}
      break;
    default:
      jj_la1[31] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public Expression primary_expr() throws ParseException {
        Expression result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case VAR:
      result = var();
                                                  {if (true) return result;}
      break;
    case TRUE:
    case FALSE:
    case NULL:
    case INTEGER_LITERAL:
    case FLOATING_POINT_LITERAL:
    case STRING_LITERAL:
    case QUOTED_URI:
    case QNAME:
      result = literal();
                                                  {if (true) return result;}
      break;
    case LPAREN:
      jj_consume_token(LPAREN);
      result = expression();
      jj_consume_token(RPAREN);
                                        {if (true) return result;}
      break;
    default:
      jj_la1[32] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  public RdqlParserTokenManager token_source;
  JavaCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[33];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static private int[] jj_la1_2;
  static {
      jj_la1_0();
      jj_la1_1();
      jj_la1_2();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {0x1000000,0x0,0x0,0x1000000,0x4000,0x1040000,0x1000000,0x1000000,0x1000000,0x0,0x0,0x0,0x0,0x0,0x0,0x1000000,0x1000000,0x0,0x0,0x0,0x0,0x0,0x900,0x900,0x6c0,0x6c0,0x3000,0x3000,0x1c000,0x1c000,0x0,0x40000,0x40000,};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {0x0,0x8,0x4,0x0,0x8000,0x0,0x0,0x0,0x0,0x808000,0x87c180,0x874180,0x800000,0x30000,0x180,0x4,0x4,0x400,0x800,0x200,0x60,0x60,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3000,0x87f180,0x87c180,};
   }
   private static void jj_la1_2() {
      jj_la1_2 = new int[] {0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x2,0x2,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x2,};
   }

  public RdqlParser(java.io.InputStream stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new RdqlParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 33; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 33; i++) jj_la1[i] = -1;
  }

  public RdqlParser(java.io.Reader stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new RdqlParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 33; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 33; i++) jj_la1[i] = -1;
  }

  public RdqlParser(RdqlParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 33; i++) jj_la1[i] = -1;
  }

  public void ReInit(RdqlParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 33; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[67];
    for (int i = 0; i < 67; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 33; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 67; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
