/*  Sesame - Storage and Querying architecture for RDF and RDF Schema
 *  Copyright (C) 2001-2005 Aduna
 *
 *  Contact: 
 *  	Aduna
 *  	Prinses Julianaplein 14 b
 *  	3817 CS Amersfoort
 *  	The Netherlands
 *  	tel. +33 (0)33 465 99 87
 *  	fax. +33 (0)33 465 99 87
 *
 *  	http://aduna.biz/
 *  	http://www.openrdf.org/
 *  
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.openrdf.sesame.sailimpl.nativerdf.btree;

/**
 *
 **/
public interface BTreeValueComparator {

	/**
	 * Compares the supplied <tt>key</tt> to the value of length <tt>length</tt>,
	 * starting at offset <tt>offset</tt> in the supplied <tt>data</tt> array.
	 *
	 * @param key A byte array representing the search key.
	 * @param data A byte array containing the value to compare the key to.
	 * @param offset The offset (0-based) of the value in <tt>data</tt>.
	 * @param length The length of the value.
	 * @return A negative integer when the key is smaller than the value, a
	 * positive integer when the key is larger than the value, or <tt>0</tt>
	 * when the key is equal to the value.
	 **/
	public int compareBTreeValues(byte[] key, byte[] data, int offset, int length);
}
