package com.mkdoc.io;

/*
    Created:  2004-11-05
    Issued:   2004-11-05
    Modified: 2004-11-05

    Author:    Philip Shaw <phil@mkdoc.com>
    Copyright: (c) 2004 MKDoc Ltd.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or (at
    your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    USA
*/

import java.io.File;
import java.io.FileFilter;

/**
 *  A basic Java source file filter.
 *  @version    0.1
 *  @author     Philip Shaw <phil@mkdoc.com>
 */
public class JavaFileFilter implements FileFilter {

    /**
     *  The Java source file extension.
     *  @since  Version 0.1 2004-11-05
     */
    private static final String EXT = ".java";

    /**
     *  Accept files with a <code>.java</code> extension.
     *  @param  pathname    A file reference to check.
     *  @return <code>true</code> if the path ends with
     *          <code>.java</code>.
     *  @since  Version 0.1 2004-11-05
     */
    public final boolean accept(final File pathname) {

        return (pathname.getName().endsWith(EXT));
    }

}
