package com.mkdoc.schema;

/*
    Created:    2005-05-25
    Issued:     2005-05-25
    Modified:   2005-05-25

    Author:     Philip Shaw <phil@mkdoc.com>
    Copyright:  (c) 2005 MKDoc Ltd.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or (at
    your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    USA
*/

/**
 *  A basic metadata resolver interface.
 *  @version    0.1 2005-05-25
 *  @author     Philip Shaw <phil@mkdoc.com>
 *  @TODO       May ultimately transfer all methods to ApplicationProfile
 */
public interface Resolver {

    /**
     *  Expand an encoded predicate to a URI.
     *  @param  predicate   The predicate to expand,
     *          including any schema prefix.
     *  @return The expanded URI reference for the
     *          predicate or the original string if it is
     *          not matched.
     *  @since  Version 0.1 2005-05-25
     */
    String expandPredicate(final String predicate);

    /**
     *  Expand an encoded scheme value to a URI.
     *  @param  scheme  The scheme to expand.
     *  @return The expanded URI reference for the scheme,
     *          or the original string if it is not
     *          matched.
     *  @since  Version 0.1 2005-05-25
     */
    String expandScheme(final String scheme);

}
