package com.mkdoc.store;

/*
    Created:    2005-04-26
    Issued:     2005-05-11
    Modified:   2005-07-14

    Author:     Philip Shaw <phil@mkdoc.com>
    Copyright:  (c) 2005 MKDoc Ltd.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or (at
    your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    USA
*/

import com.mkdoc.util.ApplicationContext;

/**
 *  Manage HTML resources stored on a file system.
 *  <p>
 *    This interim version duplicates many of the methods in the
 *    com.mkdoc.jspider package plugin classes. Should ultimately be moved to
 *    a manager hierarchy of its own with more limited, specific interface.
 *  </p>
 *  @version    0.5 2005-05-31
 *  @author     Philip Shaw <phil@mkdoc.com>
 */
public class HtmlFileStoreManager extends AbstractFileStoreManager
                                                 implements FileStoreManager {

    /**
     *  Initialize the manager.
     *  @param  context The application context for this manager.
     *  @since  Version 0.1 2005-04-26
     */
    public final void initialize(final ApplicationContext context) {

        configureOutput(context);
    }

    /**
     *  Get the extension for storage files.
     *  @return An N-Triple file extension.
     *  @since  Version 0.1 2005-04-26
     */
    public final String getExtension() {

        return ".html";
    }

    /**
     *  Shut down the manager, not implemented.
     *  @since  Version 0.1 2005-04-26
     */
    public final void shutdown() {

        // Empty;
    }

}
