package com.mkdoc.store;

/*
    Created:    2005-03-31
    Issued:     2005-03-31
    Modified:   2005-07-14

    Author:     Philip Shaw <phil@mkdoc.com>
    Copyright:  (c) 2005 MKDoc Ltd.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or (at
    your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    USA
*/

import com.mkdoc.util.ApplicationContext;

/**
 *  Basic functional features for a manager type.
 *  @version    0.3 2005-07-12
 *  @author     Philip Shaw <phil@mkdoc.com>
 */
public interface Manager {

    /**
     *  Initialize the manager.
     *  @param  context The application context for the manager.
     *  @since  Version 0.1 2005-03-31
     */
    void initialize(final ApplicationContext context);

    /**
     *  Shut down the manager.
     *  @since  Version 0.1 2005-03-31
     */
    void shutdown();

}
