package com.mkdoc.tag;

/*
    Created:    2005-07-04
    Issued:     2005-07-04
    Modified:   2005-10-14

    Author:     Philip Shaw <phil@mkdoc.com>
    Copyright:  (c) 2005 MKDoc Ltd.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or (at
    your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    USA
*/

import javax.servlet.jsp.tagext.TagSupport;

/**
 *  String constants for XHTML tags.
 *  @version    0.2 2005-10-14
 *  @author     Philip Shaw <phil@mkdoc.com>
 */
public abstract class AbstractXhtmlTag extends TagSupport {

    /**
     *  Shut a label element.
     *  @since  Version 0.1 2005-07-04
     */
    public static final String SHUT_LABEL = "</label>";

    /**
     *  Open a table data element.
     *  @since  Version 0.1 2005-07-04
     */
    public static final String OPEN_TD = "<td>";

    /**
     *  Shut a table data element.
     *  @since  Version 0.1 2005-07-04
     */
    public static final String SHUT_TD = "</td>";

    /**
     *  Open a table heading element.
     *  @since  Version 0.1 2005-07-04
     */
    public static final String OPEN_TH = "<th>";

    /**
     *  Shut a table heading element.
     *  @since  Version 0.1 2005-07-04
     */
    public static final String SHUT_TH = "</th>";

    /**
     *  Open a table row element.
     *  @since  Version 0.1 2005-07-04
     */
    public static final String OPEN_TR = "<tr>";

    /**
     *  Shut a table row element.
     *  @since  Version 0.1 2005-07-04
     */
    public static final String SHUT_TR = "</tr>";

    /**
     *  End an attribute and opening tag.
     *  @since  Version 0.1 2005-07-04
     */
    public static final String END_ATTR_TAG = "\">";
}
