package com.mkdoc.jspider;

/*
    Created:    2004-12-16
    Issued:     2004-12-16
    Modified:   2004-12-16

    Author:     Philip Shaw <phil@mkdoc.com>
    Copyright:  (c) 2004 MKDoc Ltd.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or (at
    your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    USA
*/

import net.javacoding.jspider.api.event.JSpiderEvent;

import net.javacoding.jspider.spi.Plugin;

/**
 *  Mock MKDoc plugin for testing.
 *  @version    0.1 2004-12-16
 *  @author     Philip Shaw <phil@mkdoc.com>
 */
public class MockMKDocPlugin extends AbstractMKDocPlugin implements Plugin {

    /**
     *  The plugin name.
     *  @since  Version 0.1 2004-12-16
     */
    private String name;

    /**
     *  The plugin description.
     *  @since  Version 0.1 2004-12-16
     */
    private String description;

    /**
     *  The plugin version.
     *  @since  Version 0.1 2004-12-16
     */
    private String version;

    /**
     *  The most recent JSpider event.
     *  @since  Version 0.1 2004-12-16
     */
    private JSpiderEvent event;

    /**
     *  Get the plugin name.
     *  @return The plugin name.
     *  @since  Version 0.1 2004-12-16
     */
    public final String getName() {

        return name;
    }

    /**
     *  Set the plugin name.
     *  @param  name    The plugin name.
     *  @since  Version 0.1 2004-12-16
     */
    public final void setName(final String name) {

        this.name = name;
    }

    /**
     *  Get the plugin description.
     *  @return The plugin description.
     *  @since  Version 0.1 2004-12-16
     */
    public final String getDescription() {

        return description;
    }

    /**
     *  Set the plugin description.
     *  @param  description The plugin description.
     *  @since  Version 0.1 2004-12-16
     */
    public final void setDescription(final String description) {

        this.description = description;
    }

    /**
     *  Get the plugin version.
     *  @return The plugin version.
     *  @since  Version 0.1 2004-12-16
     */
    public final String getVersion() {

        return version;
    }

    /**
     *  Set the plugin version.
     *  @param  version The plugin version.
     *  @since  Version 0.1 2004-12-16
     */
    public final void setVersion(final String version) {

        this.version = version;
    }

    /**
     *  Notify a JSpider event.
     *  @param  event   The event to report.
     *  @since  Version 0.1 2004-12-16
     */
    public final void notify(final JSpiderEvent event) {

        this.event = event;
    }

    /**
     *  Get the most recent JSpider event.
     *  @return The most recent JSpider event.
     *  @since  Version 0.1 2004-12-16
     */
    public final JSpiderEvent getLastEvent() {

        return event;
    }

}
