package com.mkdoc.store;

/*
    Created:    2005-05-17
    Issued:     2005-05-17
    Modified:   2005-05-17

    Author:     Philip Shaw <phil@mkdoc.com>
    Copyright:  (c) 2005 MKDoc Ltd.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or (at
    your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    USA
*/

import net.javacoding.jspider.core.util.config.PropertySet;

/**
 *  A mock manager type with no public constructors, for testing.
 *  @version    0.1 2005-05-17
 *  @author     Philip Shaw <phil@mkdoc.com>
 */
public final class MockManagerNoConstructor {

    /**
     *  Private constructor to prevent instantiation.
     *  @since  Version 0.1 2005-05-17
     */
    private MockManagerNoConstructor() {

        // Empty
    }

    /**
     *  Initialize the manager.
     *  @param  propertySet A property set that configures the manager.
     *  @since  Version 0.1 2005-05-17
     */
    public final void initialize(final PropertySet propertySet) {

        // Empty;
    }

    /**
     *  Shut down the manager.
     *  @since  Version 0.1 2005-05-17
     */
    public final void shutdown() {

        // Empty;
    }

}
