package com.mkdoc.store;

/*
    Created:    2005-04-29
    Issued:     2005-04-29
    Modified:   2005-04-29

    Author:     Philip Shaw <phil@mkdoc.com>
    Copyright:  (c) 2005 MKDoc Ltd.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or (at
    your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    USA
*/

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 *  Test suite for <code>StoreException</code>.
 *  @version    0.1 2005-04-29
 *  @author Philip Shaw <phil@mkdoc.com>
 */
public class StoreExceptionTest extends TestCase {

    /**
     *  An exception message.
     *  @since  Version 0.1 2005-04-29
     */
    protected static final String MESSAGE = "StoreExceptionTest message";

    /**
     *  Named test instance.
     *  @param  name    The name of the test case.
     *  @since  Version 0.1 2005-04-29
     */
    public StoreExceptionTest(final String name) {

        super(name);
    }

    /**
     *  Set up a test scenario as required.
     *  @since  Version 0.1 2005-
    protected void setUp() {

    }
     */

    /**
     *  Test the constructor.
     *  @since  Version 0.1 2005-04-29
     */
    public final void testConstructor() {

        StoreException exception = new StoreException(MESSAGE);

        assertTrue(MESSAGE.equals(exception.getMessage()));
    }

    /**
     *  Tear down a test scenario as required.
     *  @since  Version 0.1 2005-
    protected void tearDown() {

    }
     */

    /**
     *  Create a test suite for this test case.
     *  @return A test suite.
     *  @since  Version 0.1 2005-04-29
     */
    public static Test suite() {

        return new TestSuite(StoreExceptionTest.class);
    }

    /**
     *  Run this test suite as a stand alone application.
     *  @param  args    Any command line arguments to pass
     *          to the test. None required or expected.
     *  @since  Version 0.1 2005-04-29
     */
    public static void main(final String[] args) {

        junit.textui.TestRunner.run(suite());
    }

}
