package com.mkdoc.util;

/*
    Created:    2005-10-18
    Issued:     2005-10-18
    Modified:   2005-10-18

    Author:     Philip Shaw <phil@mkdoc.com>
    Copyright:  (c) 2005 MKDoc Ltd.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or (at
    your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
    USA
*/

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 *  Test suite for <code>ApplicationContextException</code>.
 *  @version    0.1 2005-10-18
 *  @author Philip Shaw <phil@mkdoc.com>
 */
public class ApplicationContextExceptionTest extends TestCase {

    /**
     *  Named test instance.
     *  @param  name    The name of the test case.
     *  @since  Version 0.1 2005-10-18
     */
    public ApplicationContextExceptionTest(final String name) {

        super(name);
    }

    /**
     *  Set up a test scenario as required.
     *  @since  Version 0.1 2005-10-18
    protected void setUp() {

    }
     */

    /**
     *  Test the constructor with a custom message.
     *  @since  Version 0.1 2005-10-18
     */
    public final void testConstructor() {

        String message = "Fatal flaw detected.";

        Exception exception = new ApplicationContextException(message);

        String testMessage = exception.getMessage();

        assertTrue(testMessage.equals(message));

        assertTrue(exception instanceof RuntimeException);
    }

    /**
     *  Tear down a test scenario as required.
     *  @since  Version 0.1 2005-10-18
    protected void tearDown() {

    }
     */

    /**
     *  Create a test suite for this test case.
     *  @return A test suite.
     *  @since  Version 0.1 2005-10-18
     */
    public static Test suite() {

        return new TestSuite(ApplicationContextExceptionTest.class);
    }

    /**
     *  Run this test suite as a stand alone application.
     *  @param  args    Any command line arguments to pass
     *          to the test. None required or expected.
     *  @since  Version 0.1 2005-10-18
     */
    public static void main(final String[] args) {

        junit.textui.TestRunner.run(suite());
    }

}
